<?php
class madmimiModelPps extends modelPps {
	private $_client = null;
	private $_lastRequireConfirm = false;
	public function getClient($username, $apiKey) {
		if($this->_client)
			return $this->_client;
		if(!class_exists('MadMimi')) {
			require_once($this->getModule()->getModDir(). 'classes'. DS. 'MadMimi.class.php');
		}
		$this->_client = new MadMimi($username, $apiKey);
		return $this->_client;
	}
	public function getLists($d) {
		$username = isset($d['username']) ? trim($d['username']) : false;
		$apiKey = isset($d['api_key']) ? trim($d['api_key']) : false;
		if(!empty($apiKey)) {
			if(!empty($username)) {
				$listsData = array();
				$listsRes = $this->getClient($username, $apiKey)->Lists();

				if(!empty($listsRes)) {
					$xmlLists = simplexml_load_string($listsRes);
					if(!empty($xmlLists)) {

						if($xmlLists->count() > 0) {
							foreach($xmlLists->children() as $l) {
								$listsData[] = array('id' => (string)$l['id'], 'name' => (string)$l['name']);
							}
							return $listsData;
						} else
							$this->pushError(__('You have no lists', PPS_LANG_CODE));

					} else
						$this->pushError(__('Problem to create XML object', PPS_LANG_CODE));
				} else
					$this->pushError(__('Problem to load results from API server', PPS_LANG_CODE));
			} else 
				$this->pushError(__('Please enter your Username or Email', PPS_LANG_CODE), 'params[tpl][sub_mm_username]');
		} else
			$this->pushError(__('Please enter your API key', PPS_LANG_CODE), 'params[tpl][sub_mm_api_key]');
		return false;
		
	}
	public function subscribe($d, $popup, $validateIp = false) {
		$email = isset($d['email']) ? trim($d['email']) : false;
		if(!empty($email)) {
			if(is_email($email)) {
				$lists = isset($popup['params']['tpl']['sub_mm_lists']) ? $popup['params']['tpl']['sub_mm_lists'] : array();
				if(!empty($lists)) {
					if(!$validateIp || $validateIp && framePps::_()->getModule('subscribe')->getModel()->checkOftenAccess(array('only_check' => true))) {
						$username = $popup['params']['tpl']['sub_mm_username'];
						$apiKey = $popup['params']['tpl']['sub_mm_api_key'];
						
						$name = isset($d['name']) ? trim($d['name']) : '';
						$client =  $this->getClient($username, $apiKey);
						$addData = array('email' => $email);
						if(!empty($name)) {
							$firstLastName = explode(' ', $name);
							$addData['firstName'] = $firstLastName[ 0 ];
							if(isset($firstLastName[ 1 ]) && !empty($firstLastName[ 1 ])) {
								$addData['lastName'] = $firstLastName[ 1 ];
							}
						}
						if(isset($popup['params']['tpl']['sub_fields'])
							&& !empty($popup['params']['tpl']['sub_fields'])
						) {
							foreach($popup['params']['tpl']['sub_fields'] as $k => $f) {
								if(in_array($k, array('name', 'email'))) continue;	// Ignore standard fields
								if(isset($d[ $k ])) {
									$addData[$k] = $d[ $k ]; 
								}
							}
						}
						foreach($lists as $listId) {
							$addData['add_list'] = $listId;
							$client->AddUser($addData);
						}
						return true;
					}
				} else
					$this->pushError (__('No lists to add selected in admin area - contact site owner to resolve this issue.', PPS_LANG_CODE));
			} else
				$this->pushError (framePps::_()->getModule('subscribe')->getModel()->getInvalidEmailMsg($popup), 'email');
		} else
			$this->pushError (framePps::_()->getModule('subscribe')->getModel()->getInvalidEmailMsg($popup), 'email');
		return false;
	}
	public function requireConfirm() {
		if($this->_lastRequireConfirm)
			return true;
		$destData = framePps::_()->getModule('subscribe')->getDestByKey( $this->getCode() );
		return $destData['require_confirm'];
	}
}