<?php
class sub_fieldsPps extends modulePps {
	public function init() {
		parent::init();
		dispatcherPps::addAction('beforePopupEditRender', array($this, 'addAdminAssets'));
		dispatcherPps::addAction('afterPopupEdit', array($this, 'addAdminControls'));
		
	}
	public function addAdminAssets($popup) {
		framePps::_()->addScript(PPS_CODE. '.admin.sub_fields', $this->getModPath(). 'js/admin.sub_fields.js');
		framePps::_()->addScript(PPS_CODE. '.admin.recaptcha', $this->getModPath(). 'js/admin.recaptcha.js');
	}
	public function addFrontendAssets() {
		framePps::_()->addScript(PPS_CODE. '.frontend.sub_fields', $this->getModPath(). 'js/frontend.sub_fields.js');
	}
	public function addAdminControls($popup) {
		$this->getView()->displayAdminControls();
	}
	public function generateValuePreset( $preset ) {
		$res = '';
		switch($preset) {
			case 'user_ip':
				$res = utilsPps::getIP();
				break;
			case 'user_country_code': case 'user_country_label':
				importClassPps('SxGeo', PPS_HELPERS_DIR. 'SxGeo.php');
				$sxGeo = new SxGeo(PPS_FILES_DIR. 'SxGeo.dat');
				$ip = utilsPps::getIP ();
				$res = $sxGeo->getCountry( $ip );
				if($preset == 'user_country_label' && $res) {
					$res = framePps::_()->getTable('countries')->get('name', array('iso_code_2' => $res), '', 'one');
				}
				break;
			case 'page_url':
				$res = uriPps::getFullUrl();
				break;
			case 'page_title':	// We will take page title from frontend - because it can be different depending on wp settings and other plugins / themes
				$this->addFrontendAssets();
				break;
		}
		return $res;
	}
	public function validateReCaptcha($reCaptchaSecret, $response) {
		$response = wp_remote_post('https://www.google.com/recaptcha/api/siteverify', array(
			'body' => array(
				'secret' => $reCaptchaSecret,
				'response' => $response,
				'remoteip' => utilsPps::getIP(),
			),
		));
		if (!is_wp_error($response)) {
			if(isset($response['body']) && !empty($response['body']) && ($resArr = utilsPps::jsonDecode($response['body']))) {
				if(isset($resArr['success']) && $resArr['success']) {
					return true;
				} else {
					$errorsDesc = array(
						'missing-input-secret' => __('reCaptcha: The secret parameter is missing.', PPS_LANG_CODE),
						'invalid-input-secret' => __('reCaptcha: The secret parameter is invalid or malformed.', PPS_LANG_CODE),
						'missing-input-response' => __('Please prove that you are not a robot - check reCaptcha.', PPS_LANG_CODE),
						'invalid-input-response' => __('reCaptcha: The response parameter is invalid or malformed.', PPS_LANG_CODE),
					);
					$errors = array();
					foreach($resArr['error-codes'] as $errCode) {
						if(isset($errorsDesc[ $errCode ])) {
							$errors[] = $errorsDesc[ $errCode ];
						}
					}
					$this->pushError(empty($errors) ? $resArr['error-codes'] : $errors);
				}
			} else
				$this->pushError(__('There was a problem with sending request to Google reCaptcha validation server. Please make sure that your server have possibility to send server-server requests. Ask your hosting provider about this.', PPS_LANG_CODE));
		} else
			$this->pushError( $response->get_error_message() );
		return false;
	}
}